Index: /LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90	(revision 2542)
@@ -68,5 +68,6 @@
 
 #ifdef CPP_RRTM
-    USE YOERAD   , ONLY : NRADLP
+    USE YOERAD, ONLY : NRADLP
+    USE YOESW, ONLY : RSUN
 #endif
     USE ioipsl_getin_p_mod, ONLY : getin_p
@@ -115,4 +116,6 @@
     !! d_t_dyn-input-R-tendance dynamique pour "t" (K/s)
     !! d_q_dyn-input-R-tendance dynamique pour "q" (kg/kg/s)
+    !! d_ql_dyn-input-R-tendance dynamique pour "ql" (kg/kg/s)
+    !! d_qs_dyn-input-R-tendance dynamique pour "qs" (kg/kg/s)
     !! flxmass_w -input-R- flux de masse verticale
     !! d_u-----output-R-tendance physique de "u" (m/s/s)
@@ -366,11 +369,7 @@
     real, save :: ale_bl_prescr=0.
 
-    real, save :: ale_max=1000.
-    real, save :: alp_max=2.
-
     real, save :: wake_s_min_lsp=0.1
 
     !$OMP THREADPRIVATE(alp_bl_prescr,ale_bl_prescr)
-    !$OMP THREADPRIVATE(ale_max,alp_max)
     !$OMP THREADPRIVATE(wake_s_min_lsp)
 
@@ -436,5 +435,4 @@
     LOGICAL,SAVE :: ok_adjwk=.FALSE.
     !$OMP THREADPRIVATE(ok_adjwk) 
-    REAL, dimension(klon) :: www
     REAL, SAVE :: alp_offset
     !$OMP THREADPRIVATE(alp_offset)
@@ -681,4 +679,6 @@
     save ratqsbas,ratqshaut,tau_ratqs
     !$OMP THREADPRIVATE(ratqsbas,ratqshaut,tau_ratqs)
+    REAL, SAVE :: ratqsp0=50000., ratqsdp=20000.
+    !$OMP THREADPRIVATE(ratqsp0, ratqsdp)
 
     ! Parametres lies au nouveau schema de nuages (SB, PDF)
@@ -835,5 +835,5 @@
     !
     !--STRAT AEROSOL
-    LOGICAL, SAVE :: flag_aerosol_strat
+    INTEGER, SAVE :: flag_aerosol_strat
     !$OMP THREADPRIVATE(flag_aerosol_strat)
     !c-fin STRAT AEROSOL
@@ -1041,6 +1041,4 @@
     forall (k=1: nbp_lev) zmasse(:, k) = (paprs(:, k)-paprs(:, k+1)) / rg
 
-
-
     modname = 'physiq'
     !IM
@@ -1055,4 +1053,6 @@
        CALL getin_p('random_notrig_max',random_notrig_max)
        CALL getin_p('ok_adjwk',ok_adjwk)
+       CALL getin_p('ratqsp0',ratqsp0)
+       CALL getin_p('ratqsdp',ratqsdp)
     ENDIF
 
@@ -1597,8 +1597,6 @@
     !--store initial water burden
     qql1(:)=0.0
-    DO i = 1, klon
-      DO k = 1, klev
-        qql1(i)=qql1(i)+(q_seri(i,k)+ql_seri(i,k))*zmasse(i,k)
-      ENDDO
+    DO k = 1, klev
+      qql1(:)=qql1(:)+(q_seri(:,k)+ql_seri(:,k)+qs_seri(:,k))*zmasse(:,k)
     ENDDO
     ENDIF
@@ -1654,51 +1652,38 @@
     !
     IF (ancien_ok) THEN
-       DO k = 1, klev
-          DO i = 1, klon
-             d_u_dyn(i,k) = (u_seri(i,k)-u_ancien(i,k))/dtime
-             d_v_dyn(i,k) = (v_seri(i,k)-v_ancien(i,k))/dtime
-             d_t_dyn(i,k) = (t_seri(i,k)-t_ancien(i,k))/dtime
-             d_q_dyn(i,k) = (q_seri(i,k)-q_ancien(i,k))/dtime
-          ENDDO
-       ENDDO
+    !
+       d_u_dyn(:,:)  = (u_seri(:,:)-u_ancien(:,:))/dtime
+       d_v_dyn(:,:)  = (v_seri(:,:)-v_ancien(:,:))/dtime
+       d_t_dyn(:,:)  = (t_seri(:,:)-t_ancien(:,:))/dtime
+       d_q_dyn(:,:)  = (q_seri(:,:)-q_ancien(:,:))/dtime
+       d_ql_dyn(:,:) = (ql_seri(:,:)-ql_ancien(:,:))/dtime
+       d_qs_dyn(:,:) = (qs_seri(:,:)-qs_ancien(:,:))/dtime
+       CALL water_int(klon,klev,q_seri,zmasse,zx_tmp_fi2d)
+       d_q_dyn2d(:)=(zx_tmp_fi2d(:)-prw_ancien(:))/dtime
+       CALL water_int(klon,klev,ql_seri,zmasse,zx_tmp_fi2d)
+       d_ql_dyn2d(:)=(zx_tmp_fi2d(:)-prlw_ancien(:))/dtime
+       CALL water_int(klon,klev,qs_seri,zmasse,zx_tmp_fi2d)
+       d_qs_dyn2d(:)=(zx_tmp_fi2d(:)-prsw_ancien(:))/dtime
        ! !! RomP >>>   td dyn traceur
-       !!     IF (nqtot.GE.3) THEN       ! jyg
-       !!        DO iq = 3, nqtot        ! jyg
-       IF (nqtot.GE.nqo+1) THEN     ! jyg
+       IF (nqtot.GT.nqo) THEN     ! jyg
           DO iq = nqo+1, nqtot      ! jyg
-             DO k = 1, klev
-                DO i = 1, klon
-                   !! d_tr_dyn(i,k,iq-2)= &                               ! jyg
-                   !!    (tr_seri(i,k,iq-2)-tr_ancien(i,k,iq-2))/dtime    ! jyg
-                   d_tr_dyn(i,k,iq-nqo)= &                                ! jyg
-                        (tr_seri(i,k,iq-nqo)-tr_ancien(i,k,iq-nqo))/dtime ! jyg
-                   !         iiq=niadv(iq)
-                   ! print*,i,k," d_tr_dyn",d_tr_dyn(i,k,iq-nqo),"tra:",iq,&
-                   !  tname(iiq)
-                ENDDO
-             ENDDO
+              d_tr_dyn(:,:,iq-nqo)=(tr_seri(:,:,iq-nqo)-tr_ancien(:,:,iq-nqo))/dtime ! jyg
           ENDDO
        ENDIF
        ! !! RomP <<<
     ELSE
-       DO k = 1, klev
-          DO i = 1, klon
-             d_u_dyn(i,k) = 0.0
-             d_v_dyn(i,k) = 0.0
-             d_t_dyn(i,k) = 0.0
-             d_q_dyn(i,k) = 0.0
-          ENDDO
-       ENDDO
+       d_u_dyn(:,:)  = 0.0
+       d_v_dyn(:,:)  = 0.0
+       d_t_dyn(:,:)  = 0.0
+       d_q_dyn(:,:)  = 0.0
+       d_ql_dyn(:,:) = 0.0
+       d_qs_dyn(:,:) = 0.0
+       d_q_dyn2d(:)  = 0.0
+       d_ql_dyn2d(:) = 0.0
+       d_qs_dyn2d(:) = 0.0
        ! !! RomP >>>   td dyn traceur
-       !!     IF (nqtot.GE.3) THEN                                     ! jyg
-       !!        DO iq = 3, nqtot                                      ! jyg
-       IF (nqtot.GE.nqo+1) THEN                                        ! jyg
-          DO iq = nqo+1, nqtot                                         ! jyg
-             DO k = 1, klev
-                DO i = 1, klon
-                   !! d_tr_dyn(i,k,iq-2)= 0.0                            ! jyg
-                   d_tr_dyn(i,k,iq-nqo)= 0.0                             ! jyg
-                ENDDO
-             ENDDO
+       IF (nqtot.GT.nqo) THEN                                       ! jyg
+          DO iq = nqo+1, nqtot                                      ! jyg
+              d_tr_dyn(:,:,iq-nqo)= 0.0                             ! jyg
           ENDDO
        ENDIF
@@ -2303,134 +2288,13 @@
        !>jyg
        !
-
-       ! Calcul de l'energie disponible ALE (J/kg) et de la puissance
-       ! disponible ALP (W/m2) pour le soulevement des particules dans
-       ! le modele convectif
-       !
-       do i = 1,klon
-          ALE(i) = 0.
-          ALP(i) = 0.
-       enddo
-       !
-       !calcul de ale_wake et alp_wake
-       if (iflag_wake>=1) then
-          if (itap .le. it_wape_prescr) then
-             do i = 1,klon
-                ale_wake(i) = wape_prescr
-                alp_wake(i) = fip_prescr
-             enddo
-          else
-             do i = 1,klon
-                !jyg  ALE=WAPE au lieu de ALE = 1/2 Cstar**2
-                !cc           ale_wake(i) = 0.5*wake_cstar(i)**2
-                ale_wake(i) = wake_pe(i)
-                alp_wake(i) = wake_fip(i)
-             enddo
-          endif
-       else
-          do i = 1,klon
-             ale_wake(i) = 0.
-             alp_wake(i) = 0.
-          enddo
-       endif
-       !combinaison avec ale et alp de couche limite: constantes si pas
-       !de couplage, valeurs calculees dans le thermique sinon
-       if (iflag_coupl.eq.0) then
-          if (debut.and.prt_level.gt.9) &
-               WRITE(lunout,*)'ALE et ALP imposes'
-          do i = 1,klon
-             !on ne couple que ale
-             !           ALE(i) = max(ale_wake(i),Ale_bl(i))
-             ALE(i) = max(ale_wake(i),ale_bl_prescr)
-             !on ne couple que alp
-             !           ALP(i) = alp_wake(i) + Alp_bl(i)
-             ALP(i) = alp_wake(i) + alp_bl_prescr
-          enddo
-       else
-          IF(prt_level>9)WRITE(lunout,*)'ALE et ALP couples au thermique'
-          !         do i = 1,klon
-          !             ALE(i) = max(ale_wake(i),Ale_bl(i))
-          ! avant        ALP(i) = alp_wake(i) + Alp_bl(i)
-          !             ALP(i) = alp_wake(i) + Alp_bl(i) + alp_offset ! modif sb
-          !         write(20,*)'ALE',ALE(i),Ale_bl(i),ale_wake(i)
-          !         write(21,*)'ALP',ALP(i),Alp_bl(i),alp_wake(i)
-          !         enddo
-
-          ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-          ! Modif FH 2010/04/27. Sans doute temporaire.
-          ! Deux options pour le alp_offset : constant si >?? 0 ou
-          ! proportionnel ??a w si <0
-          ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-          ! Estimation d'une vitesse verticale effective pour ALP
-          if (1==0) THEN
-             www(1:klon)=0.
-             do k=2,klev-1
-                do i=1,klon
-                   www(i)=max(www(i),-omega(i,k)*RD*t_seri(i,k) &
-                        /(RG*paprs(i,k)) *zw2(i,k)*zw2(i,k))
-                   ! if (paprs(i,k)>pbase(i)) then
-                   ! calcul approche de la vitesse verticale en m/s
-                   !  www(i)=max(www(i),-omega(i,k)*RD*temp(i,k)/(RG*paprs(i,k))
-                   !             endif
-                   !   Le 0.1 est en gros H / ps = 1e5 / 1e4
-                enddo
-             enddo
-             do i=1,klon
-                if (www(i)>0. .and. ale_bl(i)>0. ) www(i)=www(i)/ale_bl(i)
-             enddo
-          ENDIF
-
-
-          do i = 1,klon
-             ALE(i) = max(ale_wake(i),Ale_bl(i))
-             !cc nrlmd le 10/04/2012----------Stochastic triggering------------
-             if (iflag_trig_bl.ge.1) then
-                ALE(i) = max(ale_wake(i),Ale_bl_trig(i))
-             endif
-             !cc fin nrlmd le 10/04/2012
-             if (alp_offset>=0.) then
-                ALP(i) = alp_wake(i) + Alp_bl(i) + alp_offset ! modif sb
-             else
-                abort_message ='Ne pas passer la car www non calcule'
-                CALL abort_physic (modname,abort_message,1)
-
-                ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-                !                                _                  _
-                ! Ajout d'une composante 3 * A * w w'2 a w'3 avec
-                ! w=www : w max sous pbase ou A est la fraction
-                ! couverte par les ascendances w' on utilise le fait
-                ! que A * w'3 = ALP et donc A * w'2 ~ ALP / sqrt(ALE)
-                ! (on ajoute 0.1 pour les singularites)
-                ALP(i)=alp_wake(i)*(1.+3.*www(i)/( sqrt(ale_wake(i))+0.1) ) &
-                     +alp_bl(i)  *(1.+3.*www(i)/( sqrt(ale_bl(i))  +0.1) )
-                !    ALP(i)=alp_wake(i)+Alp_bl(i)+alp_offset*min(omega(i,6),0.)
-                !             if (alp(i)<0.) then
-                !                print*,'ALP ',alp(i),alp_wake(i) &
-                !                     ,Alp_bl(i),alp_offset*min(omega(i,6),0.)
-                !             endif
-             endif
-          enddo
-          ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
-       endif
-       do i=1,klon
-          if (alp(i)>alp_max) then
-             IF(prt_level>9)WRITE(lunout,*)                             &
-                  'WARNING SUPER ALP (seuil=',alp_max, &
-                  '): i, alp, alp_wake,ale',i,alp(i),alp_wake(i),ale(i)
-             alp(i)=alp_max
-          endif
-          if (ale(i)>ale_max) then
-             IF(prt_level>9)WRITE(lunout,*)                             &
-                  'WARNING SUPER ALE (seuil=',ale_max, &
-                  '): i, alp, alp_wake,ale',i,ale(i),ale_wake(i),alp(i)
-             ale(i)=ale_max
-          endif
-       enddo
-
-       !fin calcul ale et alp
-       !=======================================================================
-
-
+!jyg<
+       CALL alpale( debut, itap, dtime, paprs, omega, t_seri,   &
+                    alp_offset, it_wape_prescr,  wape_prescr, fip_prescr, &
+                    ale_bl_prescr, alp_bl_prescr, &
+                    wake_pe, wake_fip,  &
+                    Ale_bl, Ale_bl_trig, Alp_bl, &
+                    Ale, Alp )
+!>jyg
+!
        ! sb, oct02:
        ! Schema de convection modularise et vectorise:
@@ -2910,133 +2774,10 @@
           ENDIF
           !>jyg
-
-          !cc nrlmd le 10/04/2012
-          !-----------Stochastic triggering-----------
-          if (iflag_trig_bl.ge.1) then
-             !
-             IF (prt_level .GE. 10) THEN
-                print *,'cin, ale_bl_stat, alp_bl_stat ', &
-                     cin, ale_bl_stat, alp_bl_stat
-             ENDIF
-
-
-             !----Initialisations
-             do i=1,klon
-                proba_notrig(i)=1.
-                random_notrig(i)=1e6*ale_bl_stat(i)-int(1e6*ale_bl_stat(i))
-                if ( random_notrig(i) > random_notrig_max ) random_notrig(i)=0.
-                if ( ale_bl_trig(i) .lt. abs(cin(i))+1.e-10 ) then 
-                   tau_trig(i)=tau_trig_shallow
-                else
-                   tau_trig(i)=tau_trig_deep
-                endif
-             enddo
-             !
-             IF (prt_level .GE. 10) THEN
-                print *,'random_notrig, tau_trig ', &
-                     random_notrig, tau_trig
-                print *,'s_trig,s2,n2 ', &
-                     s_trig,s2,n2
-             ENDIF
-
-             !Option pour re-activer l'ancien calcul de Ale_bl (iflag_trig_bl=2)
-             IF (iflag_trig_bl.eq.1) then
-
-                !----Tirage al\'eatoire et calcul de ale_bl_trig
-                do i=1,klon
-                   if ( (ale_bl_stat(i) .gt. abs(cin(i))+1.e-10) )  then
-                      proba_notrig(i)=(1.-exp(-s_trig/s2(i)))** &
-                           (n2(i)*dtime/tau_trig(i))
-                      !        print *, 'proba_notrig(i) ',proba_notrig(i)
-                      if (random_notrig(i) .ge. proba_notrig(i)) then 
-                         ale_bl_trig(i)=ale_bl_stat(i)
-                      else
-                         ale_bl_trig(i)=0.
-                      endif
-                   else
-                      proba_notrig(i)=1.
-                      random_notrig(i)=0.
-                      ale_bl_trig(i)=0.
-                   endif
-                enddo
-
-             ELSE IF (iflag_trig_bl.ge.2) then
-
-                do i=1,klon
-                   if ( (Ale_bl(i) .gt. abs(cin(i))+1.e-10) )  then
-                      proba_notrig(i)=(1.-exp(-s_trig/s2(i)))** &
-                           (n2(i)*dtime/tau_trig(i))
-                      !        print *, 'proba_notrig(i) ',proba_notrig(i)
-                      if (random_notrig(i) .ge. proba_notrig(i)) then 
-                         ale_bl_trig(i)=Ale_bl(i)
-                      else
-                         ale_bl_trig(i)=0.
-                      endif
-                   else
-                      proba_notrig(i)=1.
-                      random_notrig(i)=0.
-                      ale_bl_trig(i)=0.
-                   endif
-                enddo
-
-             ENDIF
-
-             !
-             IF (prt_level .GE. 10) THEN
-                print *,'proba_notrig, ale_bl_trig ', &
-                     proba_notrig, ale_bl_trig
-             ENDIF
-
-          endif !(iflag_trig_bl)
-
-          !-----------Statistical closure-----------
-          if (iflag_clos_bl.eq.1) then 
-
-             do i=1,klon
-                !CR: alp probabiliste
-                if (ale_bl_trig(i).gt.0.) then
-                   alp_bl(i)=alp_bl(i)/(1.-min(proba_notrig(i),0.999))
-                endif
-             enddo
-
-          else if (iflag_clos_bl.eq.2) then
-
-             !CR: alp calculee dans thermcell_main
-             do i=1,klon
-                alp_bl(i)=alp_bl_stat(i)
-             enddo
-
-          else
-
-             alp_bl_stat(:)=0.
-
-          endif !(iflag_clos_bl)
-
-          IF (prt_level .GE. 10) THEN
-             print *,'ale_bl_trig, alp_bl_stat ',ale_bl_trig, alp_bl_stat
-          ENDIF
-
-          !cc fin nrlmd le 10/04/2012
-
-          ! ------------------------------------------------------------------
-          ! Transport de la TKE par les panaches thermiques.
-          ! FH : 2010/02/01
-          !     if (iflag_pbl.eq.10) then
-          !     call thermcell_dtke(klon,klev,nbsrf,pdtphys,fm_therm,entr_therm,
-          !    s           rg,paprs,pbl_tke)
-          !     endif
-          ! -------------------------------------------------------------------
-          !IM/FH: 2011/02/23 
-          ! Couplage Thermiques/Emanuel seulement si T<0
-          if (iflag_coupl==2) then
-             IF (prt_level .GE. 10) THEN
-                print*,'Couplage Thermiques/Emanuel seulement si T<0'
-             ENDIF
-             do i=1,klon
-                if (t_seri(i,lmax_th(i))>273.) then
-                   Ale_bl(i)=0.
-                endif
-             enddo
-          endif
+!jyg<
+!
+          CALL alpale_th( dtime, lmax_th, t_seri, &
+                          cin, s2, n2,  &
+                          ale_bl_trig, ale_bl_stat, ale_bl,  &
+                          alp_bl, alp_bl_stat )
 
           do i=1,klon
@@ -3114,5 +2855,6 @@
     CALL  calcratqs(klon,klev,prt_level,lunout,        &
          iflag_ratqs,iflag_con,iflag_cld_th,pdtphys,  &
-         ratqsbas,ratqshaut,tau_ratqs,fact_cldcon,   &
+         ratqsbas,ratqshaut,ratqsp0, ratqsdp, &
+         tau_ratqs,fact_cldcon,   &
          ptconv,ptconvth,clwcon0th, rnebcon0th,     &
          paprs,pplay,q_seri,zqsat,fm_therm, &
@@ -3301,5 +3043,7 @@
                 ENDIF
 
-                CALL aeropt_lw_rrtm
+                !--call LW optical properties for tropospheric aerosols 
+                !--only works for INCA aerosol (aerosol_couple = TRUE)
+                CALL aeropt_lw_rrtm(aerosol_couple,paprs,tr_seri)
                 !
 #else
@@ -3327,15 +3071,27 @@
        !--STRAT AEROSOL
        !--updates tausum_aero,tau_aero,piz_aero,cg_aero
-       IF (flag_aerosol_strat) THEN
+       IF (flag_aerosol_strat.GT.0) THEN
           IF (prt_level .GE.10) THEN
              PRINT *,'appel a readaerosolstrat', mth_cur
           ENDIF
           IF (iflag_rrtm.EQ.0) THEN
+           IF (flag_aerosol_strat.EQ.1) THEN
              CALL readaerosolstrato(debut)
+           ELSE
+             abort_message='flag_aerosol_strat must equal 1 for rrtm=0'
+             call abort_physic(modname,abort_message,1)
+           ENDIF
           ELSE
 #ifdef CPP_RRTM
-             CALL readaerosolstrato_rrtm(debut)
+            IF (flag_aerosol_strat.EQ.1) THEN
+             CALL readaerosolstrato1_rrtm(debut)
+            ELSEIF (flag_aerosol_strat.EQ.2) THEN
+             CALL stratosphere_mask(t_seri, pplay, latitude_deg)
+             CALL readaerosolstrato2_rrtm(debut)
+            ELSE
+             abort_message='flag_aerosol_strat must equal 1 or 2 for rrtm=1'
+             call abort_physic(modname,abort_message,1)
+            ENDIF
 #else
-
              abort_message='You should compile with -rrtm if running ' &
                   // 'with iflag_rrtm=1'
@@ -3345,5 +3101,4 @@
        ENDIF
        !--fin STRAT AEROSOL
-
 
        !   On prend la somme des fractions nuageuses et des contenus en eau
@@ -3673,4 +3428,13 @@
        !albedo SB <<<
 
+!--if ok_suntime_rrtm we use ancillay data for RSUN 
+!--previous values are therefore overwritten
+!--this is needed for CMIP6 runs
+!--and only possible for new radiation scheme
+       IF (iflag_rrtm.EQ.1.AND.ok_suntime_rrtm) THEN 
+#ifdef CPP_RRTM
+         CALL read_rsun_rrtm(debut)
+#endif
+       ENDIF
 
        if (mydebug) then
@@ -3726,4 +3490,5 @@
              print *,' ->radlwsw, number 1 '
           ENDIF
+
           !
           CALL radlwsw &
@@ -3735,5 +3500,5 @@
                t_seri,q_seri,wo, &
                cldfrarad, cldemirad, cldtaurad, &
-               ok_ade.OR.flag_aerosol_strat, ok_aie, flag_aerosol, &
+               ok_ade.OR.flag_aerosol_strat.GT.0, ok_aie, flag_aerosol, &
                flag_aerosol_strat, &
                tau_aero, piz_aero, cg_aero, &
@@ -3764,4 +3529,9 @@
                ZSWFT0_i, ZFSDN0, ZFSUP0)
 
+          !--OB 30/05/2016
+          !--here we return swaero_diag to FALSE
+          !--and histdef will switch it back to TRUE if necessary
+          !--this is necessary to get the right swaero at first step
+          IF (debut) swaero_diag = .FALSE.
           !
           !IM 2eme calcul radiatif pour le cas perturbe ou au moins un
@@ -3792,5 +3562,5 @@
                      t_seri,q_seri,wo, &
                      cldfra, cldemi, cldtau, &
-                     ok_ade.OR.flag_aerosol_strat, ok_aie, flag_aerosol, &
+                     ok_ade.OR.flag_aerosol_strat.GT.0, ok_aie, flag_aerosol, &
                      flag_aerosol_strat, &
                      tau_aero, piz_aero, cg_aero, &
@@ -4297,11 +4067,14 @@
     CALL diag_slp(klon,t_seri,paprs,pplay,pphis,ptstar,pt0,slp)
     !
-    !cc prw = eau precipitable
-    DO i = 1, klon
-       prw(i) = 0.
-       DO k = 1, klev
-          prw(i) = prw(i) + &
-               q_seri(i,k)*(paprs(i,k)-paprs(i,k+1))/RG
-       ENDDO
+    !cc prw  = eau precipitable
+    !   prlw = colonne eau liquide 
+    !   prlw = colonne eau solide
+    prw(:) = 0.
+    prlw(:) = 0.
+    prsw(:) = 0.
+    DO k = 1, klev
+       prw(:)  = prw(:)  + q_seri(:,k)*zmasse(:,k)
+       prlw(:) = prlw(:) + ql_seri(:,k)*zmasse(:,k)
+       prsw(:) = prsw(:) + qs_seri(:,k)*zmasse(:,k)
     ENDDO
     !
@@ -4377,27 +4150,38 @@
     !
 
+    !--OB mass fixer 
+    !--profile is corrected to force mass conservation of water
+    IF (mass_fixer) THEN
+    qql2(:)=0.0
+    DO k = 1, klev
+      qql2(:)=qql2(:)+(q_seri(:,k)+ql_seri(:,k)+qs_seri(:,k))*zmasse(:,k)
+    ENDDO
+    DO i = 1, klon
+      !--compute ratio of what q+ql should be with conservation to what it is
+      corrqql=(qql1(i)+(evap(i)-rain_fall(i)-snow_fall(i))*pdtphys)/qql2(i)
+      DO k = 1, klev
+        q_seri(i,k) =q_seri(i,k)*corrqql
+        ql_seri(i,k)=ql_seri(i,k)*corrqql
+      ENDDO
+    ENDDO
+    ENDIF
+    !--fin mass fixer
+
     ! Sauvegarder les valeurs de t et q a la fin de la physique:
     !
-    DO k = 1, klev
-       DO i = 1, klon
-          u_ancien(i,k) = u_seri(i,k)
-          v_ancien(i,k) = v_seri(i,k)
-          t_ancien(i,k) = t_seri(i,k)
-          q_ancien(i,k) = q_seri(i,k)
-       ENDDO
-    ENDDO
-
+    u_ancien(:,:)  = u_seri(:,:)
+    v_ancien(:,:)  = v_seri(:,:)
+    t_ancien(:,:)  = t_seri(:,:)
+    q_ancien(:,:)  = q_seri(:,:)
+    ql_ancien(:,:) = ql_seri(:,:)
+    qs_ancien(:,:) = qs_seri(:,:)
+    CALL water_int(klon,klev,q_ancien,zmasse,prw_ancien)
+    CALL water_int(klon,klev,ql_ancien,zmasse,prlw_ancien)
+    CALL water_int(klon,klev,qs_ancien,zmasse,prsw_ancien)
     ! !! RomP >>>
     !CR: nb de traceurs eau: nqo
-    !  IF (nqtot.GE.3) THEN
-    IF (nqtot.GE.(nqo+1)) THEN
-       !     DO iq = 3, nqtot
+    IF (nqtot.GT.nqo) THEN
        DO iq = nqo+1, nqtot
-          DO k = 1, klev
-             DO i = 1, klon
-                !              tr_ancien(i,k,iq-2) = tr_seri(i,k,iq-2)
-                tr_ancien(i,k,iq-nqo) = tr_seri(i,k,iq-nqo)
-             ENDDO
-          ENDDO
+          tr_ancien(:,:,iq-nqo) = tr_seri(:,:,iq-nqo)
        ENDDO
     ENDIF
@@ -4483,7 +4267,5 @@
     ! Get some variables from module fonte_neige_mod
     CALL fonte_neige_get_vars(pctsrf,  &
-         zxfqcalving, zxfqfonte, zxffonte)
-
-
+         zxfqcalving, zxfqfonte, zxffonte, zxrunofflic)
 
 
@@ -4521,6 +4303,6 @@
     CALL phys_output_write(itap, pdtphys, paprs, pphis,  &
          pplay, lmax_th, aerosol_couple,                 &
-         ok_ade, ok_aie, ivap, new_aod, ok_sync,         &
-         ptconv, read_climoz, clevSTD,                   &
+         ok_ade, ok_aie, ivap, iliq, isol, new_aod,      & 
+         ok_sync, ptconv, read_climoz, clevSTD,          &
          ptconvth, d_t, qx, d_qx, zmasse,                &
          flag_aerosol, flag_aerosol_strat, ok_cdnc)
@@ -4544,24 +4326,4 @@
        CALL abort_physic (modname,abort_message,1)
     ENDIF
-
-    !--OB mass fixer 
-    !--profile is corrected to force mass conservation of water
-    IF (mass_fixer) THEN
-    qql2(:)=0.0
-    DO i = 1, klon
-      DO k = 1, klev
-        qql2(i)=qql2(i)+(q_seri(i,k)+ql_seri(i,k))*zmasse(i,k)
-      ENDDO
-    ENDDO
-    DO i = 1, klon
-      !--compute ratio of what q+ql should be with conservation to what it is
-      corrqql=(qql1(i)+(evap(i)-rain_fall(i)-snow_fall(i))*pdtphys)/qql2(i)
-      DO k = 1, klev
-        q_seri(i,k) =q_seri(i,k)*corrqql
-        ql_seri(i,k)=ql_seri(i,k)*corrqql
-      ENDDO
-    ENDDO
-    ENDIF
-    !--fin mass fixer
 
     ! 22.03.04 END
Index: /LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/radlwsw_m.F90	(revision 2542)
@@ -101,5 +101,5 @@
   ! ok_aie---input-L- apply the Aerosol Indirect Effect or not?
   ! flag_aerosol-input-I- aerosol flag from 0 to 6
-  ! flag_aerosol_strat-input-I- use stratospheric aerosols flag (T/F)
+  ! flag_aerosol_strat-input-I- use stratospheric aerosols flag (0, 1, 2)
   ! tau_ae, piz_ae, cg_ae-input-R- aerosol optical properties (calculated in aeropt.F)
   ! cldtaupi-input-R- epaisseur optique des nuages dans le visible
@@ -190,5 +190,5 @@
   LOGICAL              :: lldebug
   INTEGER, INTENT(in)  :: flag_aerosol                                   ! takes value 0 (no aerosol) or 1 to 6 (aerosols)
-  LOGICAL, INTENT(in)  :: flag_aerosol_strat                             ! use stratospheric aerosols
+  INTEGER, INTENT(in)  :: flag_aerosol_strat                             ! use stratospheric aerosols
   REAL,    INTENT(in)  :: cldfra(KLON,KLEV), cldemi(KLON,KLEV), cldtaupd(KLON,KLEV)
   REAL,    INTENT(in)  :: tau_aero(KLON,KLEV,naero_grp,2)                        ! aerosol optical properties (see aeropt.F)
Index: /LMDZ5/branches/testing/libf/phylmd/readaerosol_interp.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/readaerosol_interp.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/readaerosol_interp.F90	(revision 2542)
@@ -313,6 +313,6 @@
           ! the second half of the month
           im2=im+1
-          day2 = month_mid(im+1)
-          day1 = month_mid(im2+1)
+          day1 = month_mid(im+1)
+          day2 = month_mid(im2+1)
           IF (im2 > 12) THEN
              ! the month is december, the following thus january
@@ -330,6 +330,6 @@
           ! the second half of the month
           im2=im+1
-          day2 = month_mid(im)
-          day1 = month_mid(im2)
+          day1 = month_mid(im)
+          day2 = month_mid(im2)
        END IF
      ELSE
Index: /LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90	(revision 2542)
@@ -9,4 +9,5 @@
                                  grid2dto1d_glo
     USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
+    USE mod_phys_lmdz_omp_data, ONLY :  is_omp_root
     USE mod_phys_lmdz_para 
     USE phys_state_var_mod
@@ -64,5 +65,6 @@
     IF (debut.OR.mth_cur.NE.mth_pre) THEN
 
-    IF (is_mpi_root) THEN
+!--only root reads
+    IF (is_mpi_root.AND.is_omp_root) THEN
 
     IF (nbands.NE.2) THEN 
@@ -128,5 +130,7 @@
     CALL grid2dTo1d_glo(tauaerstrat_mois,tauaerstrat_mois_glo)
 
-    ENDIF !--is_mpi_root
+    ENDIF !--is_mpi_root and is_omp_root
+
+!$OMP BARRIER
 
 !--scatter on all proc
@@ -136,5 +140,5 @@
     mth_pre=mth_cur
 !
-    IF (is_mpi_root) THEN
+    IF (is_mpi_root.AND.is_omp_root) THEN
 !
     DEALLOCATE(tauaerstrat)
@@ -142,5 +146,7 @@
     DEALLOCATE(tauaerstrat_mois_glo)
 !
-    ENDIF !-is_mpi_root
+    ENDIF !-is_mpi_root and is_omp_root
+
+!$OMP BARRIER
 
     ENDIF !--debut ou nouveau mois
Index: /LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_lw_rrtm.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_lw_rrtm.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_lw_rrtm.F90	(revision 2542)
@@ -1,13 +1,108 @@
 !
 ! aeropt_lw_rrtm.F90 2014-05-13 C. Kleinschmitt
+!                    2016-05-03 O. Boucher 
 !
+! This routine feeds aerosol LW properties to RRTM
+! we only consider absorption (not scattering)
 
-SUBROUTINE AEROPT_LW_RRTM
+SUBROUTINE AEROPT_LW_RRTM(aerosol_couple,paprs,tr_seri)
 
+  USE dimphy
+  USE aero_mod
+  USE infotrac_phy
   USE phys_state_var_mod, ONLY : tau_aero_lw_rrtm
+  USE YOERAD, ONLY : NLW
 
   IMPLICIT NONE
 
-  tau_aero_lw_rrtm(:,:,:,:) = 1.e-15
+  INCLUDE "YOMCST.h"
+  INCLUDE "clesphys.h"
+  !
+  ! Input arguments:
+  !
+  LOGICAL, INTENT(IN)                         :: aerosol_couple
+  REAL, DIMENSION(klon,klev+1), INTENT(in)    :: paprs
+  REAL, DIMENSION(klon,klev,nbtr), INTENT(in) :: tr_seri
+  !
+  REAL, DIMENSION(klon,klev) :: zdp, mass_temp
+  ! 
+  !
+  INTEGER inu, i, k
+  INTEGER :: id_ASBCM, id_ASPOMM, id_ASSO4M, id_ASMSAM, id_CSSO4M, id_CSMSAM, id_SSSSM
+  INTEGER :: id_CSSSM, id_ASSSM, id_CIDUSTM, id_AIBCM, id_AIPOMM, id_ASNO3M, id_CSNO3M, id_CINO3M
 
+  !
+  !--absorption coefficient for CIDUST
+  REAL:: alpha_abs_CIDUST_16bands(nbands_lw_rrtm)   !--unit m2/g 
+  DATA alpha_abs_CIDUST_16bands /              & 
+       0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, & 
+       0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0  /
+  !
+  IF (NLW.NE.nbands_lw_rrtm) THEN
+     print *,'Erreur NLW doit etre egal a 16 pour cette routine'
+     stop
+  ENDIF
+  ! 
+  IF (aerosol_couple) THEN 
+  ! 
+      do i=1,nbtr
+      select case(trim(solsym(i)))
+         case ("ASBCM")
+            id_ASBCM = i
+         case ("ASPOMM")
+            id_ASPOMM = i
+         case ("ASSO4M")
+            id_ASSO4M = i
+         case ("ASMSAM")
+            id_ASMSAM = i
+         case ("CSSO4M")
+            id_CSSO4M = i
+         case ("CSMSAM")
+            id_CSMSAM = i
+         case ("SSSSM")
+            id_SSSSM = i
+         case ("CSSSM")
+            id_CSSSM = i
+         case ("ASSSM")
+            id_ASSSM = i
+         case ("CIDUSTM")
+            id_CIDUSTM = i
+         case ("AIBCM")
+            id_AIBCM = i
+         case ("AIPOMM")
+            id_AIPOMM = i
+         case ("ASNO3M")
+            id_ASNO3M = i
+         case ("CSNO3M")
+            id_CSNO3M = i
+         case ("CINO3M")
+            id_CINO3M = i
+         end select
+    enddo
+    !
+    DO k=1, klev
+       zdp(:,k) = (paprs(:,k)-paprs(:,k+1))/RG !--kg/m2
+    ENDDO
+    !
+    !--for now only consider dust
+    mass_temp(:,:)=tr_seri(:,:,id_CIDUSTM)  !--kg/kg
+    !
+    DO inu=1,NLW
+      !
+      !--total aerosol
+      tau_aero_lw_rrtm(:,:,2,inu) = mass_temp(:,:)*zdp(:,:)*1000.*alpha_abs_CIDUST_16bands(inu)
+      !--no aerosol at all
+      tau_aero_lw_rrtm(:,:,1,inu) = 0.0
+      !
+    ENDDO
+    !
+    !--avoid very small values
+    tau_aero_lw_rrtm = MAX(tau_aero_lw_rrtm,1.e-15)
+    ! 
+  ELSE !--not aerosol_couple
+    !
+    !--no LW effects if not coupled to INCA
+    tau_aero_lw_rrtm = 1.e-15
+  ENDIF
+  !
 END SUBROUTINE AEROPT_LW_RRTM
